#include "projet.h"

#define SPEED 600
#define SECONDE 60000 // A placer sur 60000 en fin de projet

unsigned long dateDernierChangement = millis ();
int aller = 1 ;

/* Ports */

int bouton1 = 8;
int bouton2 = 12 ;

int valeurBouton1 = 0;
int valeurBouton2 = 0;

int effacement_g = 220;
int effacement_g_mapp;
int effacement_d = 80;
int effacement_d_mapp;

int minute = 30;
int heure = 10 ;
int u_min=0;  //unite des minutes
int d_min=3; //dizaine des minutes
int u_heu=0;
int d_heu=1;

int pos6 =35;
int pos6_mapp;

int position_2_base; 
int position_2 = 150 ;  //hanche
int position_6 = 40; // epaule
int position_5 = 40 ; //coude
int position_13= 110;  //crayon

int position_2bis,position_6bis,position_5bis,position_13bis ;
int position_2_mapping,position_6_mapping,position_5_mapping,position_13_mapping ;  
int position_2bis_mapping,position_6bis_mapping,position_5bis_mapping, position_13bis_mapping;  

int i = 0;
         
void setup()
{
  pinMode (bouton1, INPUT) ;
  pinMode (bouton2, INPUT) ;
  
  Dynamixel.setEndless(4,OFF);
  Dynamixel.setEndless(3,OFF);
  Dynamixel.begin(1000000,2); 
  
  // init robot
  position_initiale (position_2,position_5,position_6,position_13) ;
}


void loop()
{
  
  unsigned long dateCourante = millis();
  unsigned long intervalle = dateCourante - dateDernierChangement;
  
  gestion_heure () ;    //Gere le passage 

  // EFFACEMENT
    if (intervalle > SECONDE) 
    {   
      
       effacer () ;
        
       ecrire(1,u_min);
       ecrire(2,d_min);
       ecrire(3,u_heu);
       ecrire(4,d_heu);
        
        
        dateDernierChangement = dateCourante ; 
        minute++; 
        u_min++; //augmentation de la variable a ecrire
        
        if(u_min>9) // si u_min=10 on met les unites a 0 et on incremente les dizaines
        {
          u_min=0;
          d_min++;
        } 
    }   
}

void gestion_heure () 
{
   if (d_min == 6)
  {
     minute = 0;
     u_min=0;//on reinitialise les minutes a 0;
     d_min=0;
     heure ++ ;
     u_heu++;
     if(u_heu>9)
     {
       u_heu=0;
       d_heu++;
     }
  }
  if (heure == 12)
  {
    // software_Reboot () ;
    heure = 0 ;
    u_heu=0;
    d_heu=0;     
  }
}

void effacer () {
  
  // Effacement avec la ficelle
  
  Dynamixel.setEndless(4,ON);
  Dynamixel.setEndless(3,ON);

  if (aller == 1) {
  Dynamixel.turn(3,LEFT,500);
  Dynamixel.turn(4,LEFT,500);

    while (valeurBouton1 == 0)
    {
      valeurBouton1 = digitalRead(bouton1) ;
    }
    aller = -1 ;
  }

  else if (aller == -1) {
  Dynamixel.turn(3,RIGTH,500);
  Dynamixel.turn(4,RIGTH,500);
  
    while (valeurBouton2 == 0)
    {
      valeurBouton2 = digitalRead(bouton2) ;
    }
    
  aller = 1;
  }
  
  Dynamixel.turn(3,LEFT,0);
  Dynamixel.turn(4,RIGTH,0);

  valeurBouton1 = 0;
  valeurBouton2 = 0 ;
}


/* Fonctions pour l'écriture des chiffres  */


void ecrire (int cadrant, int num) // Position sur les quadrants
{     
    if (cadrant==1)       //place 1 d_heu;   place 2->u_heu;  3->d_min;  4->u_min  
    {
        position_2_base = 162 ;
        position_2 = 165;
        position_2_mapping = map (position_2_base,0,300,0,1023) ;
        Dynamixel.moveSpeed(2,position_2_mapping,100);  

        attente_ecrire () ;
        
        position_6 = 30;
        position_6_mapping = map (pos6,0,300,0,1023) ;
        
        pos6_mapp = map (pos6,0,300,0,1023) ;
        Dynamixel.moveSpeed(6,pos6_mapp,100);  
              
        position_5 = 43;
        position_5_mapping = map (position_5,0,300,0,1023) ;
        Dynamixel.moveSpeed(5,position_5_mapping,100);  

       action(num) ;
    }
    
    if (cadrant==2)
    { 

        position_2_base = 152 ;
        position_2 = 155;
        position_2_mapping = map (position_2_base,0,300,0,1023) ;
        Dynamixel.moveSpeed(2,position_2_mapping,100);  

        attente_ecrire () ;

        position_6 = 30;
        position_6_mapping = map (pos6,0,300,0,1023) ;
        pos6_mapp = map (pos6,0,300,0,1023) ;
        Dynamixel.moveSpeed(6,pos6_mapp,100);  
        
        position_5 = 42;
        position_5_mapping = map (position_5,0,300,0,1023) ;
        Dynamixel.moveSpeed(5,position_5_mapping,100);  

        action(num) ;
    }
    if (cadrant==3)
    {

        position_2_base = 142 ;
        position_2 = 145;
        position_2_mapping = map (position_2_base,0,300,0,1023) ;
        Dynamixel.moveSpeed(2,position_2_mapping,100);  

        attente_ecrire () ;

        position_6 = 30;
        position_6_mapping = map (pos6,0,300,0,1023) ;
        pos6_mapp = map (pos6,0,300,0,1023) ;
        Dynamixel.moveSpeed(6,pos6_mapp,100);  
     
        position_5 = 42;
        position_5_mapping = map (position_5,0,300,0,1023) ;
        Dynamixel.moveSpeed(5,position_5_mapping,100);  

        action(num) ;
    }
    if (cadrant==4)
    { 
      
        position_2_base = 132 ;
        position_2 = 135;
        position_2_mapping = map (position_2_base,0,300,0,1023) ;
        Dynamixel.moveSpeed(2,position_2_mapping,100);  

        attente_ecrire () ;
        
        position_6 = 30;
        position_6_mapping = map (pos6,0,300,0,1023) ;
        pos6_mapp = map (pos6,0,300,0,1023) ;
        Dynamixel.moveSpeed(6,pos6_mapp,100);  
          
        position_5 = 42;
        position_5_mapping = map (position_5,0,300,0,1023) ;
        Dynamixel.moveSpeed(5,position_5_mapping,100);  

        action(num) ;
        
        attente_ecrire () ;
        position_initiale (position_2,position_5,position_6,position_13) ;

        deux_points(position_2,position_5,position_6,position_13) ;
    }
    // ici le moteur est positioné au bon endroit il faut maintenant ecrire le chiffre
}

void action (int numero) 
{
  if (numero == 0)
  tracer_zero () ;
  else if (numero == 1)
  tracer_un () ;
  else if(numero == 2)
  tracer_deux () ;
  else if (numero == 3)
  tracer_trois () ;
  else if (numero == 4)
  tracer_quatre () ;
  else if (numero == 5)
  tracer_cinq () ;
  else if (numero == 6)
  tracer_six () ;
  else if (numero == 7)
  tracer_sept () ;
  else if (numero == 8)
  tracer_huit () ;
  else if (numero == 9)
  tracer_neuf () ;
}

/* 0 */

void tracer_zero () {
  redescendre(position_6) ;
  tiret_droite(position_2,position_5,position_6,position_13) ;
  bas_monte(position_2,position_5,position_6,position_13);
  haut_monte(position_2,position_5,position_6,position_13);
  tiret_gauche(position_2,position_5,position_6,position_13) ;
  haut_descend (position_2,position_5,position_6,position_13);
  bas_descend (position_2,position_5,position_6,position_13) ;
  remonter (position_6) ;  
  attente_ecrire () ;
}

/* 1 */

void tracer_un () {

    remonter(position_6) ;
    tiret_droite(position_2,position_5,position_6,position_13) ;
    redescendre(position_6) ;
    bas_monte(position_2,position_5,position_6,position_13);
    haut_monte(position_2,position_5,position_6,position_13);
    remonter (position_6) ;  
    attente_ecrire () ; 
}


/* 2 */

void tracer_deux () {
   redescendre(position_6) ;
   tiret_droite(position_2,position_5,position_6,position_13) ;
   tiret_gauche(position_2,position_5,position_6,position_13) ;
   bas_monte(position_2,position_5,position_6,position_13);
   tiret_droite(position_2,position_5,position_6,position_13) ;
   haut_monte(position_2,position_5,position_6,position_13);
   tiret_gauche(position_2,position_5,position_6,position_13) ;
   remonter (position_6) ;  
   attente_ecrire () ;
}


/* 3 */

void tracer_trois () {
   redescendre(position_6) ;
   tiret_droite(position_2,position_5,position_6,position_13) ;
   bas_monte(position_2,position_5,position_6,position_13);
   tiret_gauche(position_2,position_5,position_6,position_13) ;
   haut_droite(position_2,position_5,position_6,position_13);
   tiret_gauche(position_2,position_5,position_6,position_13) ;
   remonter (position_6) ;  
   attente_ecrire () ;     
}


/* 4 */

void tracer_quatre () {

  remonter(position_6) ;
  tiret_droite(position_2,position_5,position_6,position_13) ;
  redescendre(position_6) ;
  bas_monte(position_2,position_5,position_6,position_13);
  haut_monte(position_2,position_5,position_6,position_13);
  haut_descend (position_2,position_5,position_6,position_13);
  tiret_gauche(position_2,position_5,position_6,position_13) ;
  haut_monte(position_2,position_5,position_6,position_13);
  remonter (position_6) ;  
  attente_ecrire () ;   
}


/* 5 */

void tracer_cinq () {
 redescendre(position_6) ;
 tiret_droite(position_2,position_5,position_6,position_13) ;
 bas_monte(position_2,position_5,position_6,position_13);
 tiret_gauche(position_2,position_5,position_6,position_13) ;
 haut_monte(position_2,position_5,position_6,position_13);
 tiret_droite(position_2,position_5,position_6,position_13) ;
 remonter (position_6) ;  
 attente_ecrire () ;
}

/* 6 */

void tracer_six () { 
  redescendre(position_6) ;
  tiret_droite(position_2,position_5,position_6,position_13) ;
  bas_monte(position_2,position_5,position_6,position_13);
  tiret_gauche(position_2,position_5,position_6,position_13) ;
  bas_descend (position_2,position_5,position_6,position_13) ;
  bas_monte(position_2,position_5,position_6,position_13);
  haut_monte(position_2,position_5,position_6,position_13);
  tiret_droite(position_2,position_5,position_6,position_13) ;
  remonter (position_6) ;  
  attente_ecrire () ;
}

/* 7 */

void tracer_sept () {

  remonter(position_6) ;
  tiret_droite(position_2,position_5,position_6,position_13) ;
  redescendre(position_6) ;
  bas_monte(position_2,position_5,position_6,position_13);
  haut_monte(position_2,position_5,position_6,position_13);
  tiret_gauche(position_2,position_5,position_6,position_13) ;
  remonter (position_6) ;  
  attente_ecrire () ;
}

/* 8 */

void tracer_huit () {
  redescendre(position_6) ;
  tiret_droite(position_2,position_5,position_6,position_13) ;
  bas_monte(position_2,position_5,position_6,position_13);
  tiret_gauche(position_2,position_5,position_6,position_13) ;
  bas_descend (position_2,position_5,position_6,position_13) ;
  bas_monte(position_2,position_5,position_6,position_13);
  haut_monte(position_2,position_5,position_6,position_13);
  tiret_droite(position_2,position_5,position_6,position_13) ;
  haut_descend(position_2,position_5,position_6,position_13) ;
  remonter (position_6) ;  
  attente_ecrire () ;
}

/* 9 */

void tracer_neuf () {
 redescendre(position_6) ;
 tiret_droite(position_2,position_5,position_6,position_13) ;
 bas_monte(position_2,position_5,position_6,position_13);
 tiret_gauche(position_2,position_5,position_6,position_13) ;
 haut_monte(position_2,position_5,position_6,position_13);
 tiret_droite(position_2,position_5,position_6,position_13) ;
 haut_descend(position_2,position_5,position_6,position_13) ;
 remonter (position_6) ;  
 attente_ecrire () ;
}

void tiret_droite (int position2, int position5, int position6, int position13) {

   attente_ecrire () ;
   
   position_2bis = position_2+3; 
   position_2bis_mapping = map (position_2bis,0,300,0,1023) ;
   Dynamixel.moveSpeed(2,position_2bis_mapping,50);
}

void tiret_gauche (int position2, int position5, int position6, int position13) {

    attente_ecrire () ;
    position_2bis = position_2-3; 
    position_2bis_mapping = map (position_2bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(2,position_2bis_mapping,50);
}

void bas_monte (int position2, int position5, int position6, int position13) {

    attente_ecrire () ;
    position_6bis = position_6+2;
    position_6bis_mapping = map (position_6bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(6,position_6bis_mapping,100);  
    position_5bis = position_5-7;
    position_5bis_mapping = map (position_5bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(5,position_5bis_mapping,100); 
}

void haut_droite (int position2, int position5, int position6, int position13) {

    attente_ecrire () ;
    position_2bis = position_2+3; 
    position_2bis_mapping = map (position_2bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(2,position_2bis_mapping,100);
    position_6bis = position_6+5;
    position_6bis_mapping = map (position_6bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(6,position_6bis_mapping,100);  
    position_5bis = position_5-14;
    position_5bis_mapping = map (position_5bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(5,position_5bis_mapping,100); 
  
}

void haut_monte (int position2, int position5, int position6, int position13) {

    attente_ecrire () ;
    position_6bis = position_6+5;
    position_6bis_mapping = map (position_6bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(6,position_6bis_mapping,100);  
    position_5bis = position_5-14;
    position_5bis_mapping = map (position_5bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(5,position_5bis_mapping,100); 
}

void remonter (int position6) {

    attente_ecrire () ;
    position_6bis = position_6+20;  // Releve le crayon
    position_6bis_mapping = map (position_6bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(6,position_6bis_mapping,100); 
}

void redescendre (int position6) {

    attente_ecrire () ;
    position_6bis = position_6;  // Descend le crayon
    position_6bis_mapping = map (position_6bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(6,position_6bis_mapping,100); 
}

void haut_descend (int position2, int position5, int position6, int position13) {

    bas_monte (position_2,position_5,position_6,position_13) ; 
  
}

void bas_descend (int position2, int position5, int position6, int position13) {

    attente_ecrire () ;
    position_6bis = position_6;
    position_6bis_mapping = map (position_6bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(6,position_6bis_mapping,100);  
    position_5bis = position_5;
    position_5bis_mapping = map (position_5bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(5,position_5bis_mapping,100); 
}

void position_initiale (int position2, int position5, int position6, int position13) {
  
    position_2_mapping = map (150,0,300,0,1023) ;
    Dynamixel.moveSpeed(2,position_2_mapping,100);
    
    position_5_mapping = map (position_5,0,300,0,1023) ;
    Dynamixel.moveSpeed(5,position_5_mapping,100); 
   
    position_13_mapping = map (position_13,0,300,0,1023) ;
    Dynamixel.moveSpeed(13,position_13_mapping,100);  
  
    position_6_mapping = map (position_6,0,300,0,1023) ;
    Dynamixel.moveSpeed(6,position_6_mapping,100);  
}

void deux_points (int position2, int position5, int position6, int position13) {  
        
    attente_ecrire () ;
            
    position_6bis = 30;
    position_6_mapping = map (position_6bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(6,position_6_mapping,100);  
              
    position_5bis = 43;
    position_5_mapping = map (position_5bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(5,position_5_mapping,100); 
       
    attente_ecrire () ; 
    remonter (position_6) ;
    attente_ecrire () ;
    
    position_6bis = 35;
    position_6_mapping = map (position_6bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(6,position_6_mapping,100);  
              
    position_5bis = 30;
    position_5_mapping = map (position_5bis,0,300,0,1023) ;
    Dynamixel.moveSpeed(5,position_5_mapping,100);
    
    remonter (position_6) ;  
}

void dance () {

  int now = millis() ;
  int end_now = millis()+10000 ;
  int sens = 1 ;

  while (now<end_now)
  {
    if (sens == 1)
    {
      // Mouvement
      sens = -1;
    }
    else
    {
     // Mouvement inverse
      sens = 1;
    }
    now = millis() ;
  }

   position_initiale (position_2,position_5,position_6,position_13) ;
}

void attente_ecrire(){

  int now = millis() ;
  int end_now = millis()+900 ;

  while (now<end_now) 
    now = millis() ;
}
